Description

When triggered with a text starting with ##, like ##a, the search query becomes #a.

The controller receives #a but returns nothing because there are no issues that match the query.

Below is a part of Rails log when the input is ##a:

Started GET "/issues/auto_complete?project_id=ecookbook&q=%23ab" for 192.168.65.1 at 2024-08-06 01

:26:32 +0000

Processing by AutoCompletesController#issues as */*

  Parameters: {"project_id"=>"ecookbook", "q"=>"#a"}

  (snip)

  Issue Load (0.4ms)  SELECT "issues".* FROM "issues" (snip) AND (issues.subject LIKE '%#a%' ESCAP

E '\') ORDER BY "issues"."id" DESC LIMIT ?  [["project_id", 1], ["LIMIT", 10]]

 I confirmed that this problem occurs in at least Redmine v5.1 and trunk.

Also, due to this problem, the system test 'test_inline_autocomplete_for_issues_with_double_hash_keep_syntax' is currently failing.

Capybara starting Puma...

* Version 6.4.2, codename: The Eagle of Durango

* Min threads: 0, max threads: 4

* Listening on http://127.0.0.1:38479

...........[Screenshot Image]: /redmine/tmp/screenshots/failures_test_inline_autocomplete_for_issu

es_with_double_hash_keep_syntax.png

F

Failure:

InlineAutocompleteSystemTest#test_inline_autocomplete_for_issues_with_double_hash_keep_syntax [tes

t/system/inline_autocomplete_test.rb:53]:

Expected false to be truthy.

...

This problem appears to be related to the following issues:

Defect #40683: InlineAutocompleteSystemTest#test_inline_autocomplete_for_issues_with_double_hash_keep_syntax failure

after #40237 fix

Defect #40362: Autocomplete double hash keep system test fails

Associated revisions

Revision 23008 - 2024-09-01 07:15 - Go MAEDA

"##" syntax auto complete does not work (#41096).

Patch by Katsuya HIDAKA (user:hidakatsuya).

Revision 23014 - 2024-09-05 04:32 - Go MAEDA

Backport r23008 from trunk to 5.1-stable (#41096).

Revision 23015 - 2024-09-05 04:38 - Go MAEDA
Backport r23008 from trunk to 5.0-stable (#41096).

Revision 23016 - 2024-09-05 08:06 - Go MAEDA

Refactor: Remove jQuery usage in inlineAutoComplete function (#41096).

History

#1 - 2024-08-06 12:31 - Katsuya HIDAKA

- File 0001-Fix-that-syntax-auto-complete-does-not-work.patch added

This patch removes the leading # from the search query so that the controller receives the correct search query.

diff --git a/public/javascripts/application.js b/public/javascripts/application.js

index fcd9aed54..47be33567 100644

--- a/public/javascripts/application.js

+++ b/public/javascripts/application.js

@@ -1164,6 +1164,11 @@ function inlineAutoComplete(element) {

             if (event.target.type === 'text' && $(element).attr('autocomplete') != 'off') {

               $(element).attr('autocomplete', 'off');

             }

+            // When triggered with a text starting with ##, like ##a, the search query will be #a.

+            // To avoid this, remove the first # from the search query.

+            if (text) {

+              text = text.replace(/^#/, '');

+            }

             remoteSearch(getDataSource('issues') + encodeURIComponent(text), function (issues) {

               return cb(issues);

             });

 I confirmed that the ## syntax auto complete works correctly in both Redmine v5.1 and the trunk, and that all unit tests and system tests pass.

I also tried adding a new definition for triggering the ## syntax in Tribute. However, I gave up on this approach because I realized that the current

implementation of Tribute always references the definition for the # syntax trigger.

ShowHide

diff --git a/app/assets/javascripts/application.js b/app/assets/javascripts/application.js

index 320efd263..ebf6295a6 100644

--- a/app/assets/javascripts/application.js

+++ b/app/assets/javascripts/application.js

@@ -1159,33 +1159,33 @@ function inlineAutoComplete(element) {

       xhr.send();

     };

-    const tribute = new Tribute({

-      collection: [

-        {

-          trigger: '#',

-          values: function (text, cb) {

-            if (event.target.type === 'text' && $(element).attr('autocomplete') != 'off') {

-              $(element).attr('autocomplete', 'off');

-            }

-            remoteSearch(getDataSource('issues') + encodeURIComponent(text), function (issues) {

-              return cb(issues);

-            });

-          },

-          lookup: 'label',

-          fillAttr: 'label',

-          requireLeadingSpace: true,

-          selectTemplate: function (issue) {

-            let leadingHash = "#" 

-            // keep ## syntax which is a valid issue syntax to show issue with title.

-            if (this.currentMentionTextSnapshot.charAt(0) === "#") {

-              leadingHash = "##" 

-            }

-            return leadingHash + issue.original.id;

-          },

-          menuItemTemplate: function (issue) {

-            return sanitizeHTML(issue.original.label);

+    const issueAutocomplete = trigger => {

+      return {

+        trigger,

+        values: function (text, cb) {

2025-04-01 2/3



+          if (event.target.type === 'text' && $(element).attr('autocomplete') != 'off') {

+            $(element).attr('autocomplete', 'off');

           }

+          remoteSearch(getDataSource('issues') + encodeURIComponent(text), function (issues) {

+            return cb(issues);

+          });

+        },

+        lookup: 'label',

+        fillAttr: 'label',

+        requireLeadingSpace: true,

+        selectTemplate: function (issue) {

+          return trigger + issue.original.id;

         },

+        menuItemTemplate: function (issue) {

+          return sanitizeHTML(issue.original.label);

+        }

+      }

+    };

+

+    const tribute = new Tribute({

+      collection: [

+        issueAutocomplete('##'),

+        issueAutocomplete('#'),

         {

           trigger: '[[',

           values: function (text, cb) {

#2 - 2024-08-23 10:58 - Go MAEDA

- Status changed from New to Confirmed

- Target version set to 5.1.4

Setting the target version to 5.1.4.

#3 - 2024-08-23 16:30 - Massimo Rossello

I think this should be backported to 5.0.x as well

#4 - 2024-09-01 07:15 - Go MAEDA

- Status changed from Confirmed to Resolved

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the fix in r23008. Thank you for your contribution.

#5 - 2024-09-05 04:39 - Go MAEDA

- Status changed from Resolved to Closed

- Target version changed from 5.1.4 to 5.0.10

Merged the fix to stable branches.

#6 - 2024-09-05 07:12 - Ko Nagase

Sorry for late, but thanks a lot for this fix!

Files

0001-Fix-that-syntax-auto-complete-does-not-work.patch 1.14 KB 2024-08-06 Katsuya HIDAKA
